Bug 8587 - top shows bogus CPU usage data
: top shows bogus CPU usage data
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/procps)
: unstable
: all Linux
: P2 normal
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2005-12-04 00:39 by
Modified: 2006-08-29 21:32 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2005-12-04 00:39:50
top из procps-3.2.5-alt4 выдаёт явно неверные данные об использовании
процессора:

top - 00:34:07 up 32 min,  6 users,  load average: 0.26, 0.30, 0.45
Tasks: 104 total,   4 running, 100 sleeping,   0 stopped,   0 zombie
CPU0  :   8.0% user,   6.8% system,   0.3% nice,  84.8% idle
Mem:   1033456K total,  1020612K used,    12844K free,     4204K buffers
Swap:   401584K total,        0K used,   401584K free,   431092K cached

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND           
 5094 vsu       20   0    12   12    4 R 99.9  0.0   0:14.64 burnK7             
    1 root       8   0   476  476  424 S  0.0  0.0   0:04.38 init               

Числа в строке CPU0 явно не соответствуют ситуации, когда почти 100% CPU
занимает burnK7.  vmstat при этом показывает данные, соответствующие
реальности.

При незагруженном процессоре тоже показывается чушь:

top - 00:35:31 up 33 min,  6 users,  load average: 0.66, 0.44, 0.48
Tasks: 103 total,   2 running, 101 sleeping,   0 stopped,   0 zombie
CPU0  :  11.3% user,   6.5% system,   0.3% nice,  81.8% idle
Mem:   1033456K total,  1020712K used,    12744K free,     4204K buffers
Swap:   401584K total,        0K used,   401584K free,   430856K cached

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND           
    1 root       8   0   476  476  424 S  0.0  0.0   0:04.38 init               
    2 root       9   0     0    0    0 S  0.0  0.0   0:00.01 keventd            
    3 root      19  19     0    0    0 S  0.0  0.0   0:00.00 ksoftirqd_CPU0     
    4 root       9   0     0    0    0 S  0.0  0.0   0:00.10 kswapd             

Ситуация, похоже, воспроизводится независимо от ядра (наблюдалась как минимум
на
i586 с ядром 2.4.29-std-up-alt9 и на x86_64 с ядром 2.6.12-std26-up-alt4).
------- Comment #1 From 2005-12-04 18:56:50 -------
На 2.6.12-std26-smp-alt4 / procps-3.2.5-alt4 не воспроизводится -- показывает
вполне нормальные значения:

Без загрузки:
CPU0  :  0.0% us,  0.0% sy,  0.0% ni, 100.0% id,  0.0% wa,  0.0% hi,  0.0% si
CPU1  :  0.0% us,  0.0% sy,  0.0% ni, 100.0% id,  0.0% wa,  0.0% hi,  0.0% si
CPU2  :  0.0% us,  0.0% sy,  0.0% ni, 100.0% id,  0.0% wa,  0.0% hi,  0.0% si
CPU3  :  0.3% us,  0.0% sy,  0.0% ni, 99.7% id,  0.0% wa,  0.0% hi,  0.0% si

С ней:
CPU0  :  0.3% us,  0.0% sy,  0.0% ni, 99.7% id,  0.0% wa,  0.0% hi,  0.0% si
CPU1  : 100.0% us,  0.0% sy,  0.0% ni,  0.0% id,  0.0% wa,  0.0% hi,  0.0% si
CPU2  :  0.0% us,  0.0% sy,  0.0% ni, 100.0% id,  0.0% wa,  0.0% hi,  0.0% si
CPU3  :  0.0% us,  0.0% sy,  0.0% ni, 100.0% id,  0.0% wa,  0.0% hi,  0.0% si
------- Comment #2 From 2005-12-04 19:28:50 -------
предыдущий коммент относился к x86_64 системе.

на CelM с 2.6.12-wks26-up-alt4 / procps-3.2.5-alt4 положение идентично описанию vsu.
------- Comment #3 From 2005-12-05 04:12:22 -------
Что нужно сделать, чтобы это воспроизвести?
На i586 с 2.4.26-std-smp-alt13 и на x86_64 с 2.6.12-std26-smp-alt4 у меня всё OK.
------- Comment #4 From 2005-12-05 12:51:43 -------
Похоже, баг проявляется только на однопроцессорной машине.
------- Comment #5 From 2005-12-05 13:24:14 -------
После отката на procps-3.2.5-alt3 проблема не проявляется, вероятно, все дело в
"- Applied Owl patch for top." у procps-3.2.5-alt4
------- Comment #6 From 2005-12-05 21:55:10 -------
Indeed.  Fixed in 3.2.5-alt5